#
# uspk09.rb
#
# $Id: uspk09.rb,v 1.1 2000/11/22 14:36:03 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


N = 200
M = 5
x = NArray.sfloat(N)
y = NArray.sfloat(N)
yc = NArray.sfloat(N, M)
a = NArray.sfloat(M)

#-----------------------------------------------------------------------
dt = 1.0/(N-1)
for j in 0..M-1
  jj = j*2+1
  a[j] = (-1.0)**(j+1) *2.0/(jj*PI)
end

x = x.indgen * dt
for i in 0..N-1
  t = dt*i*2*PI
  y[i] = 0.0
  for j in 0..M-1
    jj = j*2+1
    yc[i,j] = a[j]*cos(jj*t)
    y[i]  = y[i] + yc[i,j]
  end
end

#--------------------------- 1ST PAGE ----------------------------------
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
rundef = glrget('RUNDEF')
gropn iws

grfrm
grsvpt(0.2, 0.8, 0.2, 0.6)
usspnt(rundef, yc)

ussttl('X-AXIS', ' ', 'COMPONENTS', ' ')
usgrph(x, yc[true,0])

for j in 1..M-1
  ip = j.divmod(4)[1] + 1
  uulinz(x, yc[true, j], 1, ip)
end

#     --- NEW FIG ---
grfig
grsvpt(0.2, 0.8, 0.62, 0.82)
uzlset('LABELXB', false)

ussttl('X-AXIS', ' ', 'TOTAL', ' ')
usgrph(x, y)

#--------------------------- 2ND PAGE ----------------------------------
grfrm
grsvpt(0.2, 0.8, 0.2, 0.6)

uzfact(0.5)
uzlset('LABELXB', true)

usspnt(rundef, yc)
ussttl('X-AXIS', ' ', 'COMPONENTS', ' ')
usgrph(x, yc[true,0])

for j in 1..M-1
  ip = j.divmod(4)[1] + 1
  uulinz(x, yc[true, j], 1, ip)
end

#     --- NEW FIG ---
grfig
grsvpt(0.2, 0.8, 0.62, 0.82)
uzlset('LABELXB', false)

ussttl('X-AXIS', ' ', 'TOTAL', ' ')
usgrph(x, y)

grcls

