#
# uupk06.rb
#
# $Id: uupk06.rb,v 1.1 2000/11/23 08:19:15 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


N = 100
M = 5
y1 = NArray.sfloat(N)
y2 = NArray.sfloat(N)
a = NArray.sfloat(M)

#-----------------------------------------------------------------------
dt = 1.0/(N-1)
pi = 3.14159
for j in 0..M-1
  jj = j*2+1
  a[j] = (-1.0)**(j+1) *2.0/(jj*pi)
end

for i in 0..N-1
  t = dt*i*2*pi
  y1[i] = a[0]*cos(t)
  y2[i] = 0.0
  for j in 0..M-1
    jj = j*2+1
    yy = a[j]*cos(jj*t)
    y2[i]  = y2[i] + yy
  end
end

#-----------------------------------------------------------------------
rundef = glrget('RUNDEF')

iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm
sglset('LCLIP', true)

usspnt(rundef, y1)
usspnt(rundef, y2)
grswnd(0.0, 1.0, rundef, rundef)
uspfit
grstrf

usdaxs

uusarp(5999, 4999)
uvdif(rundef, y1, y2)
uulin(rundef, y1)
uulin(rundef, y2)

grfrm
sglset('LCLIP', true)

usspnt(y1, rundef)
usspnt(y2, rundef)
grswnd(rundef, rundef, 0.0, 1.0)
uspfit
grstrf

usdaxs

uhdif(y1, y2, rundef)
uulin(y1, rundef)
uulin(y2, rundef)

grcls

