#
# u2d3.rb
#   $Id: u2d3.rb,v 1.2 2000/11/18 19:03:45 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 37
NY = 37
MY = 7
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
DRAD = PI / 180
p = NArray.sfloat(NX, NY)
uy1 = NArray.sfloat(NY)
uy2 = NArray.sfloat(MY)

ch = ['SP ', '60S', '30S', 'EQ ', '30N', '60N', 'NP ']

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1)) * DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1)) * DRAD
    slat = sin(alat)
    uy1[j] = slat
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)
  end
end

for j in 0..MY-1
  uy2[j] = sin((YMIN + (YMAX-YMIN)*j/(MY-1)) * DRAD )
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

grswnd(XMIN, XMAX, -1.0, 1.0)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uxaxdv('B', 10.0, 60.0)
uxaxdv('T', 10.0, 60.0)
uxsttl('B', 'LONGITUDE', 0.0)

uyaxdv('L', 0.1, 0.5)
uysttl('L', 'SINE LATITUDE', 0.0)

uzlset('LABELYR', true)
uyaxlb('R', uy1, uy2, ch, 3)
uysttl('R', 'LATITUDE', 0.0)

uwsgxb(XMIN, XMAX, NX)
uwsgya(uy1)

udcntr(p)

grcls

